/*	$Id: rtld_start.S,v 1.5 2003/03/03 18:19:38 tsubai Exp $	*/

/*-
 * Copyright (c) 1998,2002 Tsubai Masanari.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <machine/asm.h>

	.text

	.globl	_rtld_start
_rtld_start:
	stwu	1,-48(1)
	stw	3,12(1)			# argc
	stw	4,16(1)			# argv
	stw	5,20(1)			# envp
/*	stw	6,24(1)			# obj		(always 0) */
/*	stw	7,28(1)			# cleanup	(always 0) */
	stw	8,32(1)			# ps_strings

	bl	1f
0:
	.long	_GLOBAL_OFFSET_TABLE_-4-0b
	.long	_DYNAMIC-0b
1:
	mflr	5
	lwz	4,0(5)
	add	3,4,5			# r3 = _GLOBAL_OFFSET_TABLE_ - 4

	dcbst	0,3			# sync i-cache with d-cache
	sync
	icbi	0,3
	sync
	isync

	addi	31,3,4			# r31 = (real) GOT

	lwz	4,4(5)
	add	3,4,5			# r3 = (real) _DYNAMIC
	lwz	4,0(31)			# r4 = base-relative _DYNAMIC
	sub	30,3,4			# r30 = displacement
	mr	4,30
	bl      _rtld_relocate_nonplt_self@plt

	lwz	4,16(1)
	addi	3,4,-12			# sp = &argv[-3]	/* XXX */
	mr	4,30
	bl	_rtld@plt		# _start = _rtld(sp, displacement)
	mtlr	3

	lwz	3,12(1)			# argc
	lwz	4,16(1)			# argv
	lwz	5,20(1)			# envp
	lwz	6,-8(4)			# obj = sp[1] (== argv[-2])
	lwz	7,-12(4)		# cleanup = sp[0] (== argv[-3])
	lwz	8,32(1)			# ps_strings

	addi	1,1,48
	blrl		# _start(argc, argv, envp, obj, cleanup, ps_strings)

	li	0,1			# _exit()
	sc

	.globl	_rtld_bind_start
_rtld_bind_start:
	stwu	1,-48(1)
	mflr	0
	stw	0,52(1)			# save lr
	mfcr	0
	stw	0,8(1)			# save cr
	stw	3,12(1)			# save r3-r10
	stw	4,16(1)
	stw	5,20(1)
	stw	6,24(1)
	stw	7,28(1)
	stw	8,32(1)
	stw	9,36(1)
	stw	10,40(1)

	mr	3,12			# obj
	mr	4,11			# reloff
	bl	_rtld_bind@plt		# _rtld_bind(obj, reloff)
	mtctr	3

	lwz	0,8(1)			# restore cr
	mtcr	0
	lwz	3,12(1)			# restore r3-r10
	lwz	4,16(1)
	lwz	5,20(1)
	lwz	6,24(1)
	lwz	7,28(1)
	lwz	8,32(1)
	lwz	9,36(1)
	lwz	10,40(1)
	lwz	0,52(1)			# restore lr
	mtlr	0

	addi	1,1,48
	bctr

	.globl	_rtld_powerpc_pltcall
	.globl	_rtld_powerpc_pltresolve
_rtld_powerpc_pltcall:
	slwi	11,11,2
	addis	11,11,0			# addis	11,11,jmptab@ha
	lwz	11,0(11)		# lwz	11,jmptab@l(11)
	mtctr	11
	bctr

_rtld_powerpc_pltresolve:
	lis	12,0			# lis	12,_rtld_bind_start@ha
	addi	12,12,0			# addi	12,12,_rtld_bind_start@l
	mtctr	12
	lis	12,0			# lis	12,obj@ha
	addi	12,12,0			# addi	12,12,obj@l
	bctr
