/*	$Id: start.S,v 1.3 2003/09/23 13:38:29 tsubai Exp $	*/

/*-
 * Copyright (c) 1998, 2003 Tsubai Masanari.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <machine/asm.h>
#include <machine/bat.h>

#define STACKSIZE 8192

#ifdef XCOFF_GLUE
	.text
	.globl	_entry
_entry:
	.long	_start,0,0
#endif

	.lcomm	stack,STACKSIZE+16,16

ENTRY(_start)
	mfmsr	8
	li	0,0
	mtmsr	0
	isync

	mtibatu	0,0
	mtibatu	1,0
	mtibatu	2,0
	mtibatu	3,0
	mtdbatu	0,0
	mtdbatu	1,0
	mtdbatu	2,0
	mtdbatu	3,0

	li	9,BATL(0, BATL_M)
	mtibatl	0,9
	mtdbatl	0,9
	li	9,BATU(0, BATU_256M)
	mtibatu	0,9
	mtdbatu	0,9
	isync

	mtmsr	8
	isync

	bl	1f
1:	mflr	8
	addi	8,8,_start-1b	/* load address */
	lis	9,_start@ha
	addi	9,9,_start@l	/* link address */
	cmpw	8,9
	beq	3f

	li	0,0x7fff	/* XXX (_edata-_start)/4 */
	mtctr	0
2:	lwzu	0,4(8)
	stwu	0,4(9)
	bdnz	2b

3:	lis	8,_start@ha
	addi	8,8,_start@l
	li	9,0x1000	/* XXX (_edata-_start+32)/32 */
	mtctr	9
4:	dcbf	0,8
	sync
	icbi	0,8
	addi	8,8,32
	bdnz	4b
	sync
	isync

	lis	1,stack@ha
	addi	1,1,stack@l
	addi	1,1,STACKSIZE

	ba	startup
