/*	$Id: mkboot.c,v 1.3 2002/03/29 17:51:08 tsubai Exp $	*/

/*-
 * Copyright (c) 2002 Tsubai Masanari.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <sys/disklabel.h>
#include <unistd.h>

#ifndef DEFAULT_ENTRY
#define DEFAULT_ENTRY 0x4000
#endif

int writeapplepartmap(int);

int
main()
{
	writeapplepartmap(1);
	exit(0);
}

int
writeapplepartmap(fd)
	int fd;
{
	struct drvr_map dm;
	struct part_map_entry pme;

	/* block 0 */
	bzero(&dm, sizeof dm);
	dm.sbSig = DRIVER_MAP_MAGIC;
	dm.sbBlockSize = 512;
	dm.sbBlkCount = 0;

	if (write(fd, &dm, 512) != 512)
		return -1;

	/* block 1: Apple Partition Map */
	bzero(&pme, sizeof(pme));
	pme.pmSig = PART_ENTRY_MAGIC;
	pme.pmMapBlkCnt = 2;
	pme.pmPyPartStart = 1;
	pme.pmPartBlkCnt = pme.pmDataCnt = 2;
	strcpy(pme.pmPartName, "Apple");
	strcpy(pme.pmPartType, "Apple_partition_map");
	
	pme.pmPartStatus = 0x37;

	if (write(fd, &pme, 512) != 512)
		return -1;

	/* block 2: NetBSD partition */
	bzero(&pme, sizeof(pme));
	pme.pmSig = PART_ENTRY_MAGIC;
	pme.pmMapBlkCnt = 2;
	pme.pmPyPartStart = 17;
	pme.pmPartBlkCnt = pme.pmDataCnt = 0x7fffffff;
	strcpy(pme.pmPartName, "NetBSD");
	strcpy(pme.pmPartType, "NetBSD/macppc");
	pme.pmPartStatus = 0x3b;
	pme.pmBootSize = 0x10000;	/* XXX ofwboot size */
	pme.pmBootLoad = DEFAULT_ENTRY;
	pme.pmBootEntry = DEFAULT_ENTRY;
	strcpy(pme.pmProcessor, "PowerPC");

	if (write(fd, &pme, 512) != 512)
		return -1;

	/* block 3-15 */
	bzero(&pme, sizeof(pme));
	write(fd, &pme, 512);
	write(fd, &pme, 512);
	write(fd, &pme, 512);
	write(fd, &pme, 512);
	write(fd, &pme, 512);
	write(fd, &pme, 512);
	write(fd, &pme, 512);
	write(fd, &pme, 512);
	write(fd, &pme, 512);
	write(fd, &pme, 512);
	write(fd, &pme, 512);
	write(fd, &pme, 512);
	write(fd, &pme, 512);

	/* block 16: ustar name block */
	/* block 17- ofwboot body */

	return 0;
}
