#include <sys/types.h>
#include <machine/mpc860dev.h>

static inline void
eieio()
{
	asm volatile ("eieio; sync");
}

static volatile struct cpm_bdesc *TxBD;

void
putchar(c)
	int c;
{
	if (c == '\n')
		putchar('\r');

	while (TxBD->bd_flags & 0x8000);    
	eieio();

	*(TxBD->bd_addr) = c;
	TxBD->bd_len = 1;

	eieio();
	TxBD->bd_flags |= 0x8000;              
}

void
smcinit()
{
	volatile struct mpc860dev *immr = get_immr();
	struct smc_uart *uart = (void *)((char *)immr + 0x3e80);

	TxBD = (void *)((char *)immr + uart->tbase);

#if 0
	/* Disable watchdog for now. */

#define SYPCR_SWE 0x0004
	immr->siu_sypcr &= ~SYPCR_SWE;
#endif

	/* Start timebase. */
	immr->siu_tbscr = 0x0001;
}

